function [traj, infStates] = hgf(r, p, varargin)
% Calculates the trajectories of the agent's representations under the HGF
%
% This function can be called in two ways:
% 
% (1) hgf(r, p)
%   
%     where r is the structure generated by fitModel and p is the parameter vector in native space;
%
% (2) hgf(r, ptrans, 'trans')
% 
%     where r is the structure generated by fitModel, ptrans is the parameter vector in
%     transformed space, and 'trans' is a flag indicating this.
%
% --------------------------------------------------------------------------------------------------
% Copyright (C) 2012 Christoph Mathys, TNU, UZH & ETHZ
%
% This file is part of the HGF toolbox, which is released under the terms of the GNU General Public
% Licence (GPL), version 3. You can redistribute it and/or modify it under the terms of the GPL
% (either version 3 or, at your option, any later version). For further details, see the file
% COPYING or <http://www.gnu.org/licenses/>.


% Transform paramaters back to their native space if needed
if ~isempty(varargin) && strcmp(varargin{1},'trans');
    p = hgf_transp(r, p);
end

% Number of levels
try
    l = r.c_prc.n_levels;
catch
    l = length(p)/4;
    
    if l ~= floor(l)
        error('Cannot determine number of levels');
    end
end

% Unpack parameters
mu_0 = p(1:l);
sa_0 = p(l+1:2*l);
ka   = p(2*l+1:3*l-1);
om   = p(3*l:4*l-2);
th   = p(4*l-1);
al   = p(4*l);

% Add dummy "zeroth" trial
u = [0; r.u(:,1)];

% Number of trials (including prior)
n = length(u);

% Initialize updated quantities

% Representations
mu = NaN(n,l);
pi = NaN(n,l);

% Other quantities
pihat = NaN(n,l);
w     = NaN(n,l-1);
da    = NaN(n,l-1);
dau   = NaN(n,1);

% Representation priors
% Note: first entries of the other quantities remain
% NaN because they are undefined and are thrown away
% at the end; their presence simply leads to consistent
% trial indices.
mu(1,:) = mu_0;
pi(1,:) = 1./sa_0;

% Representation update loop
% Pass through trials 
for k = 2:1:n
    if not(ismember(k-1, r.ign))
        
        %%%%%%%%%%%%%%%%%%%%%%
        % Effect of input u(k)
        %%%%%%%%%%%%%%%%%%%%%%
        
        % 1st level
        % ~~~~~~~~~
        % Precision of prediction
        pihat(k,1) = 1/(1/pi(k-1,1) +exp(ka(1) *mu(k-1,2) +om(1)));
        
        % Input prediction error
        dau(k) = u(k) -mu(k-1,1);
        
        % Updates
        pi(k,1) = pihat(k,1) +1/al;
        mu(k,1) = mu(k-1,1) +1/pihat(k,1) *1/(1/pihat(k,1) +al) *dau(k);

        % Volatility prediction error
        da(k,1) = (1/pi(k,1) +(mu(k,1) -mu(k-1,1))^2) *pihat(k,1) -1;
        
        if l > 2
            % Pass through higher levels
            % ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            for j = 2:l-1
                % Precision of prediction
                pihat(k,j) = 1/(1/pi(k-1,j) +exp(ka(j) *mu(k-1,j+1) +om(j)));

                % Weighting factor
                w(k,j-1) = exp(ka(j-1) *mu(k-1,j) +om(j-1)) *pihat(k,j-1);

                % Updates
                pi(k,j) = pihat(k,j) +1/2 *ka(j-1)^2 *w(k,j-1) *(w(k,j-1) +(2 *w(k,j-1) -1) *da(k,j-1));

                if pi(k,j) <= 0
                    error('Error: negative posterior precision. Parameters are in a region where model assumptions are violated.');
                end

                mu(k,j) = mu(k-1,j) +1/2 *1/pi(k,j) *ka(j-1) *w(k,j-1) *da(k,j-1);
    
                % Volatility prediction error
                da(k,j) = (1/pi(k,j) +(mu(k,j) -mu(k-1,j))^2) *pihat(k,j) -1;
            end
        end

        % Last level
        % ~~~~~~~~~~
        % Precision of prediction
        pihat(k,l) = 1/(1/pi(k-1,l) +th);

        % Weighting factor
        w(k,l-1) = exp(ka(l-1) *mu(k-1,l) +om(l-1)) *pihat(k,l-1);
        
        % Updates
        pi(k,l) = pihat(k,l) +1/2 *ka(l-1)^2 *w(k,l-1) *(w(k,l-1) +(2 *w(k,l-1) -1) *da(k,l-1));

        if pi(k,l) <= 0
            error('Error: negative posterior precision. Parameters are in a region where model assumptions are violated.');
        end

        mu(k,l) = mu(k-1,l) +1/2 *1/pi(k,l) *ka(l-1) *w(k,l-1) *da(k,l-1);
    
        % Volatility prediction error
        da(k,l) = (1/pi(k,l) +(mu(k,l) -mu(k-1,l))^2) *pihat(k,l) -1;
    else

        mu(k,:) = mu(k-1,:); 
        pi(k,:) = pi(k-1,:);

        pihat(k,:) = pihat(k-1,:);
        
        w(k,:)  = w(k-1,:);
        da(k,:) = da(k-1,:);
        
    end
end

% Get predictions on mu
muhat = mu;
muhat(end,:) = [];

% Remove representation priors
mu(1,:)  = [];
pi(1,:)  = [];

% Remove other dummy initial values
pihat(1,:) = [];
w(1,:)     = [];
da(1,:)    = [];
dau(1)     = [];

% Create result data structure
traj = struct;

traj.mu     = mu;
traj.sa     = 1./pi;

traj.muhat  = muhat;
traj.sahat  = 1./pihat;

traj.w      = w;
traj.da     = da;
traj.dau    = dau;

% Create matrix (in this case: matrices) needed by observation model
infStates = NaN(n-1,l,2);
infStates(:,:,1) = traj.muhat;
infStates(:,:,2) = traj.sahat;

return;
